local L = AceLibrary("AceLocale-2.2"):new("Fence_SinglePrice")
local l = AceLibrary("AceLocale-2.2"):new("Fence")
local abc = AceLibrary("Abacus-2.0")

-- Localization
L:RegisterTranslations("enUS", function() return {
		["Single Price"] = true,
	}
end)

L:RegisterTranslations("deDE", function() return {
		["Single Price"] = "Single Price",
	}
end)

Fence_SinglePrice = Fence:NewModule("SinglePrice")
	
	function Fence_SinglePrice:OnInitialize()
		self.db = Fence:AcquireDBNamespace("SinglePrice")
		
		Fence.options.args.singleprice = {
			type = 'group',
			name = L["Single Price"], aliases='sp',
			desc = string.format(l["%s options"], L["Single Price"]),
				args = {
					toggle = {
						type = 'toggle',
						name = L["Single Price"],
						desc = string.format(l["Toggles %s function."], L["Single Price"]),
						get = function() return Fence:IsModuleActive("SinglePrice") end,
						set = function(v) Fence:ToggleModuleActive("SinglePrice", v) end
					},
				}
			}
	end

	function Fence_SinglePrice:OnEnable()
		self:RegisterEvent("AH_LOADED")
	end

	function Fence_SinglePrice:OnDisable()
		if self:IsHooked("AuctionFrameBrowse_Update") then self:Unhook("AuctionFrameBrowse_Update") end
	end

	function Fence_SinglePrice:AH_LOADED()
		self:Hook("AuctionFrameBrowse_Update", true)
		self:UnregisterEvent("AH_LOADED")
	end
	
	function Fence_SinglePrice:AuctionFrameBrowse_Update()
		self.hooks["AuctionFrameBrowse_Update"]()

		local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame)
		local index, button, buttonName

		for i=1, NUM_BROWSE_TO_DISPLAY do
			index = offset + i + (NUM_AUCTION_ITEMS_PER_PAGE * AuctionFrameBrowse.page)
			local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner =  GetAuctionItemInfo("list", offset + i)
			if (name ~= nil) then
				if (buyoutPrice > 0 ) and (count > 1) then
					buttonName = "BrowseButton"..i
					local itemName = getglobal(buttonName.."Name")		
--~ 					local oText = itemName:GetText()	
					local ep = floor(buyoutPrice/count)
					local spText = string.format(" (%s)", abc:FormatMoneyShort(ep, true))
					if strlen(name) > 25 then 
						local sText = strsub(name,1,25).."..."
						itemName:SetText(sText..spText)
					else
						itemName:SetText(name..spText)
					end
				end 
			end 
		end 
	end
	
